Index: palm/trunk/SOURCE/restart_data_mpi_io_mod.f90
===================================================================
--- palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4893)
@@ -3241,79 +3253,46 @@
        INTEGER(KIND=MPI_ADDRESS_KIND) ::  rem_offs  !<
 #else
-       INTEGER(idp) ::  rem_offs
-#endif
-
-       LOGICAL ::  write_done  !<
-
-
-!
-!--    In the current version, there is only 1 value per grid cell allowed.
-!--    In this special case, the cyclical repetition can be done with the same method as for 2d-real
-!--    array.
+       INTEGER(idp) ::  rem_offs                    !<
+#endif
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_data  !<
+
+
+!
+!--    ATTENTION: This version allows only 1 surface element per grid cell.
+!
+!--    Activate grid of the smaller prerun, i.e. grid variables like nxl, nxr, nys, nyn and other
+!--    values are set according to the prerun settings.
        CALL prerun_grid%activate_grid_from_this_class()
 
        IF ( pe_active_for_read )  THEN
-          rmabuf_2d = -1.0
+
+          IF ( MAXVAL( m_end_index ) <= 0 )  THEN
+             CALL mainrun_grid%activate_grid_from_this_class()
+             IF ( debug_output )  THEN
+                CALL debug_message( 'PE inactive for reading restart or prerun data', 'start' )
+             ENDIF
+             RETURN
+          ENDIF
+
+          ALLOCATE( c_data(MAXVAL( m_end_index )) )
+
+!
+!--       Recursive CALL of rrd_mpi_io_surface.
+!--       rrd_mpi_io_surface is called with cyclic_fill_mode = .FALSE. on the smaller prerun grid.
+          cyclic_fill_mode = .FALSE.
+          CALL rrd_mpi_io_surface( name, c_data )
+          cyclic_fill_mode = .TRUE.
+
           DO  i = nxl, nxr
              DO  j = nys, nyn
-
-                IF ( m_global_start(j,i) > 0 )  THEN
-                   disp     = array_position+(m_global_start(j,i)-1) * wp
-                   nr_words = m_end_index(j,i)-m_start_index(j,i)+1
-                   nr_bytes = nr_words * wp
-                ENDIF
-                IF ( disp >= 0  .AND.  disp_f == -1 )  THEN   ! First entry
-                   disp_f     = disp
-                   nr_bytes_f = 0
-                   write_done = .TRUE.
-                ENDIF
-                IF( write_done )  THEN
-                   i_f = i
-                   j_f = j
-                   write_done = .FALSE.
-                ENDIF
-
-                IF ( j == nyn  .AND.  i == nxr )  THEN        ! Last entry
-                   disp_n = -1
-                   IF (  nr_bytes > 0 )  THEN
-                      nr_bytes_f = nr_bytes_f+nr_bytes
-                   ENDIF
-                ELSEIF ( j == nyn )  THEN                     ! Next x
-                   IF ( m_global_start(nys,i+1) > 0  .AND.  disp > 0 )  THEN
-                      disp_n = array_position + ( m_global_start(nys,i+1) - 1 ) * wp
-                   ELSE
-                      CYCLE
-                   ENDIF
-                ELSE
-                   IF ( m_global_start(j+1,i) > 0  .AND.  disp > 0 )  THEN
-                      disp_n = array_position + ( m_global_start(j+1,i) - 1 ) * wp
-                   ELSE
-                      CYCLE
-                   ENDIF
-                ENDIF
-
-
-                IF ( disp + nr_bytes == disp_n )  THEN        ! Contiguous block
-                   nr_bytes_f = nr_bytes_f + nr_bytes
-                ELSE                                          ! Read
-#if defined( __parallel )
-                   CALL MPI_FILE_SEEK( fhs, disp_f, MPI_SEEK_SET, ierr )
-                   nr_words = nr_bytes_f / wp
-                   CALL MPI_FILE_READ( fhs, rmabuf_2d(j_f,i_f), nr_words, MPI_REAL, status, ierr )
-#else
-                   CALL posix_lseek( fh, disp_f )
-                   CALL posix_read( fh, rmabuf_2d(j_f:,i_f:), nr_bytes_f )
-#endif
-
-                   disp_f     = disp
-                   nr_bytes_f = nr_bytes
-                   write_done = .TRUE.
-                ENDIF
-
+                rmabuf_2d(j,i) = c_data(c_start_index(j,i))
              ENDDO
           ENDDO
 
        ENDIF
-
+!
+!--    Activate grid of the mainrun, i.e. grid variables like nxl, nxr, nys, nyn and other values
+!--    are set according to the mainrun settings.
        CALL mainrun_grid%activate_grid_from_this_class()
 
@@ -3324,49 +3303,16 @@
 #endif
 
-       IF ( .NOT. pe_active_for_read )  THEN
-
-          is = nxl
-          ie = nxr
-          js = nys
-          je = nyn
-
-       ELSE
-
-          is = nxl
-          ie = nxr
-          js = prerun_grid%nys+1
-          je = nyn
-
-          DO  i = is, ie
-             DO  j = js, je
-                i_remote = MOD(i,nx_on_file+1)
-                j_remote = MOD(j,ny_on_file+1)
-                rem_pe   = remote_pe(i_remote,j_remote)
-                rem_offs = rma_offset(i_remote,j_remote)
-                nval     = 1
-
-#if defined( __parallel )
-                IF ( rem_pe /= myid )  THEN
-                   CALL MPI_GET( data(m_start_index(j,i)), nval, MPI_REAL, rem_pe, rem_offs, nval, &
-                                 MPI_REAL, rmawin_2d, ierr)
-                ELSE
-                   data(m_start_index(j,i)) = rmabuf_2d(j_remote,i_remote)
-                ENDIF
-#else
-                data(m_start_index(j,i)) = array_2d(i_remote,j_remote)
-#endif
-             ENDDO
-          ENDDO
-          is = prerun_grid%nxr+1
-          ie = nxr
-          js = nys
-          je = nyn
-
-       ENDIF
+!
+!--   After reading surface data on the small grid, map these data in a cyclic way to all respective
+!--   grid points of the main run.
+      is = nxl
+      ie = nxr
+      js = nys
+      je = nyn
 
        DO  i = is, ie
           DO  j = js, je
-             i_remote = MOD(i,nx_on_file+1)
-             j_remote = MOD(j,ny_on_file+1)
+             i_remote = MOD( i, nx_on_file+1 )
+             j_remote = MOD( j, ny_on_file+1 )
              rem_pe   = remote_pe(i_remote,j_remote)
              rem_offs = rma_offset(i_remote,j_remote)
@@ -3375,11 +3321,11 @@
 #if defined( __parallel )
              IF ( rem_pe /= myid )  THEN
-                CALL MPI_GET( data(m_start_index(j,i)), nval, MPI_REAL, rem_pe, rem_offs, nval,    &
+                CALL MPI_GET( data(o_start_index(j,i)), nval, MPI_REAL, rem_pe, rem_offs, nval,    &
                               MPI_REAL, rmawin_2d, ierr)
              ELSE
-                data(m_start_index(j,i)) = rmabuf_2d(j_remote,i_remote)
+                data(o_start_index(j,i)) = rmabuf_2d(j_remote,i_remote)
              ENDIF
 #else
-             data(m_start_index(j,i)) = array_2d(i_remote,j_remote)
+             data(o_start_index(j,i)) = array_2d(i_remote,j_remote)
 #endif
           ENDDO
@@ -3391,4 +3337,6 @@
        CALL MPI_WIN_FENCE( 0, rmawin_2d, ierr )
 #endif
+
+       IF ( ALLOCATED( c_data ) )  DEALLOCATE( c_data )
 
     END SUBROUTINE rrd_mpi_io_surface_cyclic_fill
@@ -3539,6 +3487,4 @@
     array_position = prt_nr_bytes
 
-    write(9,*) 'array_position after particle ',array_position,prt_nr_bytes,rs
-
     DEALLOCATE( prt_data )
 
@@ -3556,24 +3502,34 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name            !<
-
-#if defined( __parallel )
-    INTEGER(KIND=rd_offset_kind)       ::  disp            !<
-#endif
-    INTEGER(iwp), OPTIONAL             ::  first_index     !<
-#if defined( __parallel )
-    INTEGER(iwp)                       ::  i               !<
-#endif
-    INTEGER(iwp)                       ::  lo_first_index  !<
-    INTEGER(KIND=rd_offset_kind)       ::  offset          !<
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status          !<
-#endif
-
-    REAL(wp), INTENT(IN), DIMENSION(:), TARGET ::  data    !<
-
-
-    offset = 0
+    CHARACTER(LEN=*), INTENT(IN) ::  name  !<
+
+    INTEGER(iwp), OPTIONAL ::  first_index     !<
+    INTEGER(iwp) ::  i               !<
+    INTEGER(iwp) ::  j               !<
+    INTEGER(iwp) ::  lo_first_index  !<
+#if defined( __parallel )
+    INTEGER(iwp) ::  buf_start       !<
+    INTEGER(iwp) ::  ie              !<
+    INTEGER(iwp) ::  is              !<
+    INTEGER(iwp) ::  ind_gb          !<
+    INTEGER(iwp) ::  ind_out         !<
+    INTEGER(iwp) ::  n               !<
+    INTEGER(iwp) ::  n_trans         !<
+#endif
+
+#if defined( __parallel )
+    INTEGER(KIND=MPI_ADDRESS_KIND) ::  disp    !< displacement in RMA window
+    INTEGER(KIND=rd_offset_kind)   ::  offset  !<
+
+    INTEGER(iwp), DIMENSION(0:numprocs-1)   ::  lo_index  !<
+    INTEGER(iwp), DIMENSION(rd_status_size) ::  status    !<
+#endif
+
+    REAL(wp), INTENT(IN), DIMENSION(:), TARGET ::  data  !<
+#if defined( __parallel )
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  get_buffer  !<
+#endif
+
+
     lo_first_index = 1
 
@@ -3581,4 +3537,5 @@
        lo_first_index = first_index
     ENDIF
+
 !
 !-- In case of 2d-data, name is written only once
@@ -3586,5 +3543,6 @@
 
        IF ( header_array_index == max_nr_arrays )  THEN
-          STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+          message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+          CALL message( 'wrd_mpi_io_surface', 'PA0585', 1, 2, 0, 6, 0 )
        ENDIF
 
@@ -3596,46 +3554,80 @@
 
 #if defined( __parallel )
-    IF ( sm_io%is_sm_active() )  THEN
-       DO  i = 1, nr_val
-          array_1d(i+local_start) = data(i)
+    offset = 0
+
+    ALLOCATE( get_buffer(SUM( transfer_index(4,:) )) )
+!
+!-- Copy from input array (data) to RMA window to allow the target PEs to get the appropiate data.
+!-- At this point, a dummy surface element is added. This makes sure that every x-y grid cell owns
+!-- at least one surface element. This way, bookkeeping becomes much easier.
+    lo_index = thread_values
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          is = lo_index(target_thread(j,i)) + 1
+          ie = is + m_end_index(j,i) - m_start_index(j,i)
+!
+!--       Store number of surface elements in dummy additional surface element
+          array_1d(is-1)  = e_end_index(j,i) - e_start_index(j,i) + 1
+          array_1d(is:ie) = data(m_start_index(j,i):m_end_index(j,i))
+          lo_index(target_thread(j,i)) = lo_index(target_thread(j,i)) +                            &
+                                         e_end_index(j,i) - e_start_index(j,i) + 1
        ENDDO
-    ELSE
-!       array_1d => data                           !kk Did not work in all cases    why???
-       ALLOCATE( array_1d( SIZE( data ) ) )
-       array_1d = data
-    ENDIF
-
-    CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
+    ENDDO
+!
+!-- On target PE, get data from source PEs which are assigned for output on this PE.
+    CALL MPI_WIN_FENCE( 0, win_surf, ierr )
+
+    buf_start = 1
+    DO  n = 0, numprocs-1
+       n_trans = transfer_index(4,n)
+       IF ( n_trans > 0 )  THEN
+          disp = transfer_index(3,n) - 1
+          CALL MPI_GET( get_buffer(buf_start), n_trans, MPI_REAL, n, disp, n_trans, MPI_REAL,      &
+                        win_surf, ierr )
+          buf_start = buf_start + n_trans
+       ENDIF
+    ENDDO
+
+    CALL MPI_WIN_FENCE( 0, win_surf, ierr )
+!
+!-- Copy data to output buffer. Here, the outpuf buffer matches the indices global_start and
+!-- global_end.
+    ind_gb  = 1
+    DO  i = 1, SIZE( local_indices, 2 )
+       ind_out = local_indices(1,i)
+       DO  j = 1, local_indices(2,i)
+          array_out(ind_out) = get_buffer(ind_gb)
+          ind_out = ind_out+1
+          ind_gb  = ind_gb+1
+       ENDDO
+    ENDDO
+
+    DEALLOCATE( get_buffer )
+
+!
+!-- Write data to disk.
+    CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
     IF ( sm_io%iam_io_pe )  THEN
-       IF ( all_pes_write )  THEN
-          CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_surf, 'native', MPI_INFO_NULL,  &
-                                  ierr )
-          CALL MPI_FILE_WRITE_ALL( fh, array_1d, nr_iope, MPI_REAL, status, ierr )
-       ELSE
-          CALL MPI_FILE_SET_VIEW( fh, offset, MPI_BYTE, MPI_BYTE, 'native', MPI_INFO_NULL, ierr )
-          IF ( nr_val > 0 )  THEN
-             disp = array_position + 8 * ( glo_start - 1 )
-             CALL MPI_FILE_SEEK( fh, disp, MPI_SEEK_SET, ierr )
-             CALL MPI_FILE_WRITE( fh, array_1d, nr_iope, MPI_REAL, status, ierr )
-          ENDIF
-       ENDIF
+       CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_surf, 'native', MPI_INFO_NULL,     &
+                               ierr )
+       CALL MPI_FILE_WRITE_ALL( fh, array_out, SIZE( array_out ), MPI_REAL, status, ierr )
     ENDIF
     CALL sm_io%sm_node_barrier()
-    IF( .NOT. sm_io%is_sm_active() )  DEALLOCATE( array_1d )
-#else
+#else
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          array_out(e_start_index(j,i)) = e_end_index(j,i) - e_start_index(j,i) + 1
+          array_out(e_start_index(j,i)+1:e_end_index(j,i)) =                                       &
+                                                          data(m_start_index(j,i):m_end_index(j,i))
+       ENDDO
+    ENDDO
+
     CALL posix_lseek( fh, array_position )
-    CALL posix_write( fh, data, nr_val )
-#endif
+    CALL posix_write( fh, array_out, SIZE(array_out) )
+#endif
+
     array_position = array_position + total_number_of_surface_values * wp
 
-!    IF ( lo_first_index == 1 )  THEN
-!       IF ( debug_level >= 2 .AND. nr_val  > 0 )  WRITE(9,*) 'w_surf_1 ', TRIM( name ), ' ', nr_val, SUM( data(1:nr_val) )
-!    ELSE
-!       IF ( debug_level >= 2 .AND. nr_val  > 0 ) WRITE(9,*) 'w_surf_n ', TRIM( name ), ' ', &
-!                                                            lo_first_index, nr_val, SUM( data(1:nr_val) )
-!    ENDIF
-
  END SUBROUTINE wrd_mpi_io_surface
-
 
 
@@ -3690,10 +3682,12 @@
     IF ( wr_flag  .AND.  sm_io%iam_io_pe )  THEN
 
-       tgh%nr_int    = header_int_index - 1
-       tgh%nr_char   = header_char_index - 1
-       tgh%nr_real   = header_real_index - 1
-       tgh%nr_arrays = header_array_index - 1
-       tgh%total_nx  = iog%nx + 1
-       tgh%total_ny  = iog%ny + 1
+       tgh%nr_int      = header_int_index - 1
+       tgh%nr_char     = header_char_index - 1
+       tgh%nr_real     = header_real_index - 1
+       tgh%nr_arrays   = header_array_index - 1
+       tgh%total_nx    = iog%nx + 1
+       tgh%total_ny    = iog%ny + 1
+       tgh%pes_along_x = pdims(1)
+       tgh%pes_along_y = pdims(2)
        IF ( include_total_domain_boundaries )  THEN   ! Not sure, if LOGICAL interpretation is the same for all compilers,
           tgh%i_outer_bound = 1                       ! therefore store as INTEGER in general header
@@ -3802,9 +3796,4 @@
 !-- Close MPI-IO files
 #if defined( __parallel )
-!
-!-- Restart file has been opened with comm2d
-    IF ( fhs /= -1 )  THEN
-       CALL MPI_FILE_CLOSE( fhs, ierr )
-    ENDIF
 !
 !-- Free RMA windows
@@ -3816,5 +3805,14 @@
 #endif
 
-    IF (.NOT. pe_active_for_read )  RETURN
+    IF ( ALLOCATED( e_start_index ) )   DEALLOCATE( e_start_index  )
+    IF ( ALLOCATED( e_end_index )   )   DEALLOCATE( e_end_index    )
+    IF ( ALLOCATED( m_start_index ) )   DEALLOCATE( m_start_index  )
+    IF ( ALLOCATED( m_end_index )   )   DEALLOCATE( m_end_index    )
+    IF ( ALLOCATED( target_thread ) )   DEALLOCATE( target_thread  )
+    IF ( ALLOCATED( thread_index )  )   DEALLOCATE( thread_index   )
+    IF ( ALLOCATED( thread_values ) )   DEALLOCATE( thread_values  )
+    IF ( ALLOCATED( transfer_index ) )  DEALLOCATE( transfer_index  )
+
+    IF ( .NOT. pe_active_for_read )  RETURN
 !
 !-- TODO: better explain the following message
@@ -3860,85 +3858,200 @@
 !> data is not time critical (data size is comparably small), it will be read by all cores.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE rd_mpi_io_surface_filetypes( start_index, end_index, data_to_write, global_start )
+ RECURSIVE SUBROUTINE rd_mpi_io_surface_filetypes( start_index, end_index, data_to_write,          &
+                                                   global_start, global_end )
 
     IMPLICIT NONE
 
-    INTEGER(iwp)                          ::  i           !<  loop index
-    INTEGER(iwp)                          ::  j           !<  loop index
-    INTEGER(KIND=rd_offset_kind)          ::  offset      !<
-
-    INTEGER(iwp), DIMENSION(1)            ::  dims1       !<
-    INTEGER(iwp), DIMENSION(1)            ::  lize1       !<
-    INTEGER(iwp), DIMENSION(1)            ::  start1      !<
-
-    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  all_nr_val  !< number of values for all PEs
-    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  lo_nr_val   !< local number of values in x and y direction
-
-
-    INTEGER, INTENT(INOUT), DIMENSION(nys:nyn,nxl:nxr)  ::  end_index     !<
-    INTEGER, INTENT(OUT), DIMENSION(nys:nyn,nxl:nxr)    ::  global_start  !<
-    INTEGER, INTENT(INOUT), DIMENSION(nys:nyn,nxl:nxr)  ::  start_index   !<
-
-    LOGICAL, INTENT(OUT) ::  data_to_write  !< returns, if surface data have to be written
-
-!
-!-- Actions during reading
-    IF ( rd_flag )  THEN
-!
-!--    Set start index and end index for the mainrun grid.
-!--    ATTENTION: This works only for horizontal surfaces with one vale per grid cell!!!
-       IF ( cyclic_fill_mode )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                start_index (j,i) = (i-nxl) * nny + j - nys + 1
-                end_index (j,i)   = start_index(j,i)
-             ENDDO
+    INTEGER(iwp) ::  e_lo_start        !<
+    INTEGER(iwp) ::  i                 !<  loop index
+    INTEGER(iwp) ::  j                 !<  loop index
+    INTEGER(iwp) ::  index_offset      !<
+    INTEGER(iwp) ::  last_end_index    !<
+    INTEGER(iwp) ::  lo_start          !<
+    INTEGER(iwp) ::  nr_surfcells_pe   !<
+    INTEGER(iwp) ::  rest_cells_pe     !<
+    INTEGER(iwp) ::  rest_bound        !<
+#if defined( __parallel )
+    INTEGER(iwp) ::  io_end_index      !<
+    INTEGER(iwp) ::  io_start_index    !<
+    INTEGER(iwp) ::  n                 !<  loop index
+    INTEGER(iwp) ::  nr_previous       !<
+#endif
+
+    INTEGER(iwp), DIMENSION(0:numprocs-1,2) ::  nr_surfcells_all_s  !<
+    INTEGER(iwp), DIMENSION(0:numprocs-1,2) ::  nr_surfcells_all_r  !<
+#if defined( __parallel )
+    INTEGER(iwp), DIMENSION(1)              ::  dims1               !< global dimension for MPI_TYPE_CREATE_SUBARRAY
+    INTEGER(iwp), DIMENSION(1)              ::  lsize1              !< local size for MPI_TYPE_CREATE_SUBARRAY
+    INTEGER(iwp), DIMENSION(0:numprocs-1)   ::  nr_cells_to_thread  !<
+    INTEGER(iwp), DIMENSION(0:pdims(1))     ::  nr_surf_cells_x     !<
+    INTEGER(iwp), DIMENSION(0:pdims(1))     ::  nr_surf_cells_x_s   !<
+    INTEGER(iwp), DIMENSION(0:numprocs-1)   ::  nr_values_to_thread !<
+    INTEGER(iwp), DIMENSION(1)              ::  start1              !< start index for MPI_TYPE_CREATE_SUBARRAY
+    INTEGER(iwp), DIMENSION(nxl:nxr)        ::  sum_y               !<
+#endif
+
+    INTEGER(iwp), INTENT(INOUT), DIMENSION(nys:nyn,nxl:nxr) ::  end_index     !< local end indx
+    INTEGER(iwp), INTENT(INOUT), DIMENSION(nys:nyn,nxl:nxr) ::  global_start  !< global start index
+    INTEGER(iwp), INTENT(INOUT), DIMENSION(nys:nyn,nxl:nxr) ::  global_end    !< global end index
+    INTEGER(iwp), INTENT(INOUT), DIMENSION(nys:nyn,nxl:nxr) ::  start_index   !< local start index
+#if defined( __parallel )
+    INTEGER(iwp), DIMENSION(0:myidy,nxl:nxr)    ::  nr_previous_y      !<
+    INTEGER(iwp), DIMENSION(0:pdims(2),nxl:nxr) ::  nr_surf_cells_y    !<
+    INTEGER(iwp), DIMENSION(0:pdims(2),nxl:nxr) ::  nr_surf_cells_y_s  !<
+    INTEGER(iwp), DIMENSION(4,0:numprocs-1)     ::  transfer_index_s   !<
+#endif
+
+    LOGICAL, INTENT(OUT) ::  data_to_write      !< returns .TRUE., if surface data have been written
+    LOGICAL              ::  only_dummy_values  !< only dummy values, i.e. no data to write
+
+
+!
+!-- Clean up previous calls.
+#if defined( __parallel )
+    IF ( win_surf /= -1 )  THEN
+       CALL MPI_WIN_FREE( win_surf, ierr )
+       DEALLOCATE( array_1d )
+       win_surf = -1
+    ENDIF
+    IF ( ft_surf /= -1  .AND.  sm_io%iam_io_pe )  THEN
+       CALL MPI_TYPE_FREE( ft_surf, ierr )
+    ENDIF
+    ft_surf = -1
+    IF ( sm_io%is_sm_active() )  THEN
+       IF ( win_out /= -1 )  THEN
+          CALL MPI_WIN_FREE( win_out, ierr )
+          win_out = -1
+       ENDIF
+    ELSE
+       IF ( ASSOCIATED( array_out ) )  DEALLOCATE( array_out )
+    ENDIF
+#else
+    IF ( ASSOCIATED( array_out ) )  DEALLOCATE( array_out )
+#endif
+
+    IF ( cyclic_fill_mode )  THEN
+       CALL cyclic_fill_surface_filetype
+       RETURN
+    ELSE
+       IF ( .NOT. ALLOCATED( e_end_index )    )  ALLOCATE( e_end_index(nys:nyn,nxl:nxr)   )
+       IF ( .NOT. ALLOCATED( e_start_index )  )  ALLOCATE( e_start_index(nys:nyn,nxl:nxr) )
+       IF ( .NOT. ALLOCATED( m_end_index )    )  ALLOCATE( m_end_index(nys:nyn,nxl:nxr)   )
+       IF ( .NOT. ALLOCATED( m_start_index )  )  ALLOCATE( m_start_index(nys:nyn,nxl:nxr) )
+       IF ( .NOT. ALLOCATED( target_thread )  )  ALLOCATE( target_thread(nys:nyn,nxl:nxr) )
+       IF ( .NOT. ALLOCATED( thread_index )   )  ALLOCATE( thread_index(0:numprocs-1)     )
+       IF ( .NOT. ALLOCATED( thread_values )  )  ALLOCATE( thread_values(0:numprocs-1)    )
+       IF ( .NOT. ALLOCATED( transfer_index ) )  ALLOCATE( transfer_index(4,0:numprocs-1) )
+    ENDIF
+
+    IF ( wr_flag)  THEN
+!
+!--    Add one dummy value at every grid box.
+!--    This allows to use MPI_FILE_WRITE_ALL and MPI_FILE_READ_ALL with subarray file type.
+       index_offset   = 0
+       last_end_index = 0
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             e_start_index(j,i) = start_index (j,i) + index_offset
+             IF ( end_index (j,i) - start_index(j,i) < 0 )  THEN
+                e_end_index (j,i) = last_end_index+1
+                last_end_index    = last_end_index+1
+             ELSE
+                e_end_index (j,i) = end_index(j,i) + index_offset + 1
+                last_end_index    = e_end_index (j,i)
+             ENDIF
+             index_offset = index_offset + 1
+           ENDDO
+       ENDDO
+#if defined( __parallel )
+!
+!--    Compute indices for global, PE independent 1-d surface element array.
+       nr_surf_cells_y_s = 0
+!
+!--    Count number of surface elements in y-direction for every x.
+       DO  i = nxl, nxr
+          nr_surf_cells_y_s(myidy,i) = SUM( e_end_index (:,i) - e_start_index (:,i) + 1 )
+       ENDDO
+!
+!--    Distribute these values to all PEs along y.
+       CALL MPI_ALLREDUCE( nr_surf_cells_y_s, nr_surf_cells_y, SIZE( nr_surf_cells_y ),            &
+                           MPI_INTEGER, MPI_SUM, comm1dy, ierr )
+!
+!--    Sum all surface elements along y for individual x PEs
+       nr_surf_cells_x_s        = 0
+       nr_surf_cells_x_s(myidx) = SUM( nr_surf_cells_y )
+!
+!--    Distribute to all PEs along x.
+       CALL MPI_ALLREDUCE( nr_surf_cells_x_s, nr_surf_cells_x, SIZE( nr_surf_cells_x ),            &
+                           MPI_INTEGER, MPI_SUM, comm1dx, ierr )
+       DO  i = nxl, nxr
+          nr_previous_y(:,i) = 0
+          DO  n = 1, myidy
+             nr_previous_y(n,i) = nr_previous_y(n-1,i) + nr_surf_cells_y(n-1,i)
           ENDDO
-       ENDIF
-
-       IF ( .NOT. ALLOCATED( m_start_index )  )  ALLOCATE( m_start_index(nys:nyn,nxl:nxr)  )
-       IF ( .NOT. ALLOCATED( m_end_index )    )  ALLOCATE( m_end_index(nys:nyn,nxl:nxr)    )
-       IF ( .NOT. ALLOCATED( m_global_start ) )  ALLOCATE( m_global_start(nys:nyn,nxl:nxr) )
-!
-!--    Save arrays for later reading
-       m_start_index  = start_index
-       m_end_index    = end_index
-       m_global_start = global_start
-       nr_val = MAXVAL( end_index )
-
-    ENDIF
-
-    IF ( .NOT. pe_active_for_read )  RETURN
-
-    IF ( cyclic_fill_mode )  CALL prerun_grid%activate_grid_from_this_class()
-
-    offset = 0
-    lo_nr_val= 0
-    lo_nr_val(myid) = MAXVAL( end_index )
-#if defined( __parallel )
-    CALL MPI_ALLREDUCE( lo_nr_val, all_nr_val, numprocs, MPI_INTEGER, MPI_SUM, comm2d, ierr )
-    IF ( ft_surf /= -1  .AND.  sm_io%iam_io_pe )  THEN
-       CALL MPI_TYPE_FREE( ft_surf, ierr )    ! If set, free last surface filetype
-    ENDIF
-
-    IF ( win_surf /= -1 )  THEN
-       IF ( sm_io%is_sm_active() )  THEN
-          CALL MPI_WIN_FREE( win_surf, ierr )
-       ENDIF
-       win_surf = -1
-    ENDIF
-
-    IF ( sm_io%is_sm_active() .AND. rd_flag )  THEN
-       IF ( fhs == -1 )  THEN
-          CALL MPI_FILE_OPEN( comm2d, TRIM( io_file_name ), MPI_MODE_RDONLY, MPI_INFO_NULL, fhs,   &
-                              ierr )
-       ENDIF
+       ENDDO
+
+       sum_y(nxl) = SUM( nr_surf_cells_y(:,nxl) )
+       DO  i = nxl, nxr
+          IF ( i > nxl )  THEN
+             sum_y(i) = sum_y(i-1) + SUM( nr_surf_cells_y(:,i) )
+          ENDIF
+       ENDDO
+
+       nr_previous = 0
+       IF ( myidx >= 1 )  THEN
+          nr_previous = SUM(nr_surf_cells_x(0:myidx-1))
+       ENDIF
+
+       global_start(nys,nxl) = 1 + nr_previous + nr_previous_y(myidy,nxl)
+       DO  j = nys+1, nyn
+          global_start(j,nxl) = global_start(j-1,nxl) + e_end_index(j-1,nxl) -                     &
+                                e_start_index(j-1,nxl) + 1
+       ENDDO
+
+       DO  i = nxl+1, nxr
+          global_start(nys,i) = 1 + nr_previous + nr_previous_y(myidy,i) + sum_y(i-1)
+          DO  j = nys+1, nyn
+             global_start(j,i) = global_start(j-1,i) + e_end_index(j-1,i) - e_start_index(j-1,i) + 1
+          ENDDO
+       ENDDO
+#else
+       global_start = e_start_index
+#endif
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             global_end(j,i) = global_start(j,i) + e_end_index (j,i) - e_start_index (j,i)
+          ENDDO
+       ENDDO
+
     ELSE
-       fhs = fh
-    ENDIF
-#else
-    all_nr_val(myid) = lo_nr_val(myid)
-#endif
-    nr_val = lo_nr_val(myid)
+!
+!--    In case of read, compute e_start_index and e_end_index for current processor grid.
+!--    This data contains one extra value for every i and j.
+       e_lo_start = 1
+       lo_start   = 1
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             e_start_index(j,i) = e_lo_start
+             e_end_index(j,i)   = e_lo_start + global_end(j,i) - global_start(j,i)
+             e_lo_start         = e_lo_start + global_end(j,i) - global_start(j,i) + 1
+             start_index(j,i)   = lo_start
+             end_index(j,i)     = lo_start + global_end(j,i) - global_start(j,i) - 1
+             lo_start           = lo_start + global_end(j,i) - global_start(j,i)
+          ENDDO
+       ENDDO
+
+    ENDIF
+
+    nr_surfcells_all_s = 0
+    nr_surfcells_all_s(myid,1) = MAXVAL( e_end_index ) ! don't split surface elements of one gridbox
+    nr_surfcells_all_s(myid,2) = MAXVAL( e_end_index - e_start_index )
+
+#if defined( __parallel )
+    CALL MPI_ALLREDUCE( nr_surfcells_all_s, nr_surfcells_all_r, SIZE( nr_surfcells_all_s ),        &
+                        MPI_INTEGER, MPI_SUM, comm2d, ierr )
+#else
+    nr_surfcells_all_r = nr_surfcells_all_s
+#endif
 
     total_number_of_surface_values = 0
